/*----------------------------------------------------------------------------
 *
 * file   : filter.c for mag2
 *
 * Author : Yusuf Attarwala
 * Date   : Oct 96
 *
 *---------------------------------------------------------------------------*/

#include "globals.h"

extern void defineTexture(Picture *pic);
void doInvert(Picture *pic);

void
invertFilterCB (Widget w, XtPointer data)
{
    Picture *pic = (Picture *)data;
    doInvert(pic);
}

void
doInvert(Picture *pic)
{
    int i,j,k;
    unsigned char *t;

    k = 0;
    for (j=0;j<pic->imgHeight;j++,k++) {   /* opt ? */
        t = pic->data + k*pic->dataWidth*3;
        for (i=0;i<pic->imgWidth;i++) {
            *t = 255 - *t; t++;
            *t = 255 - *t; t++;
            *t = 255 - *t; t++;
        }
    }

    defineTexture(pic);
    drawScene(pic);
}

